std::basic_ios< _CharT, _Traits >(3cxx)

NAME
std::basic_ios< _CharT, _Traits >

SYNOPSIS

Inherits std::ios_base.

Inherited by std::basic_istream< _CharT, _Traits > [virtual], and std::basic_ostream< _CharT, _Traits > [virtual].

  Public Types

enum event { erase_event, imbue_event, copyfmt_event }
typedef void(* event_callback) (event __e, ios_base &__b, int __i)
typedef _Ios_Fmtflags fmtflags
typedef int io_state
typedef _Ios_Iostate iostate
typedef int open_mode
typedef _Ios_Openmode openmode
typedef int seek_dir
typedef _Ios_Seekdir seekdir
typedef std::streamoff streamoff
typedef std::streampos streampos

typedef _CharT char_type
typedef _Traits::int_type int_type
typedef _Traits::pos_type pos_type
typedef _Traits::off_type off_type
typedef _Traits traits_type

typedef ctype< _CharT > __ctype_type
typedef num_put< _CharT, ostreambuf_iterator< _CharT, _Traits > > __num_put_type
typedef num_get< _CharT, istreambuf_iterator< _CharT, _Traits > > __num_get_type

  Public Member Functions

basic_ios (basic_streambuf< _CharT, _Traits > *__sb)
virtual ~basic_ios ()
const locale & _M_getloc () const
void _M_setstate (iostate __state)
bool bad () const
void clear (iostate __state=goodbit)
basic_ios & copyfmt (const basic_ios &__rhs)
bool eof () const
iostate exceptions () const
void exceptions (iostate __except)
bool fail () const
char_type fill () const
char_type fill (char_type __ch)
fmtflags flags () const
fmtflags flags (fmtflags __fmtfl)
locale getloc () const
bool good () const
locale imbue (const locale &__loc)
long & iword (int __ix)
char narrow (char_type __c, char __dfault) const
streamsize precision () const
streamsize precision (streamsize __prec)
void *& pword (int __ix)
basic_streambuf< _CharT, _Traits > * rdbuf () const
basic_streambuf< _CharT, _Traits > * rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
iostate rdstate () const
void register_callback (event_callback __fn, int __index)
fmtflags setf (fmtflags __fmtfl)
fmtflags setf (fmtflags __fmtfl, fmtflags __mask)
void setstate (iostate __state)
basic_ostream< _CharT, _Traits > * tie () const
basic_ostream< _CharT, _Traits > * tie (basic_ostream< _CharT, _Traits > *__tiestr)
void unsetf (fmtflags __mask)
char_type widen (char __c) const
streamsize width () const
streamsize width (streamsize __wide)

operator bool () const
bool operator! () const

  Static Public Member Functions

static bool sync_with_stdio (bool __sync=true)
static int xalloc () throw ()

  Static Public Attributes

static const fmtflags adjustfield
static const openmode app
static const openmode ate
static const iostate badbit
static const fmtflags basefield
static const seekdir beg
static const openmode binary
static const fmtflags boolalpha
static const seekdir cur
static const fmtflags dec
static const seekdir end
static const iostate eofbit
static const iostate failbit
static const fmtflags fixed
static const fmtflags floatfield
static const iostate goodbit
static const fmtflags hex
static const openmode in
static const fmtflags internal
static const fmtflags left
static const fmtflags oct
static const openmode out
static const fmtflags right
static const fmtflags scientific
static const fmtflags showbase
static const fmtflags showpoint
static const fmtflags showpos
static const fmtflags skipws
static const openmode trunc
static const fmtflags unitbuf
static const fmtflags uppercase

  Protected Types

enum { _S_local_word_size }

  Protected Member Functions

basic_ios ()
basic_ios (const basic_ios &)=delete
void _M_cache_locale (const locale &__loc)
void _M_call_callbacks (event __ev) throw ()
void _M_dispose_callbacks (void) throw ()
_Words & _M_grow_words (int __index, bool __iword)
void _M_init () throw ()
void _M_move (ios_base &) noexcept
void _M_swap (ios_base &__rhs) noexcept
void init (basic_streambuf< _CharT, _Traits > *__sb)
void move (basic_ios &__rhs)
void move (basic_ios &&__rhs)
basic_ios & operator= (const basic_ios &)=delete
void set_rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
void swap (basic_ios &__rhs) noexcept

  Protected Attributes

_Callback_list * _M_callbacks
const __ctype_type * _M_ctype
iostate _M_exception
char_type _M_fill
bool _M_fill_init
fmtflags _M_flags
locale _M_ios_locale
_Words _M_local_word [_S_local_word_size]
const __num_get_type * _M_num_get
const __num_put_type * _M_num_put
streamsize _M_precision
basic_streambuf< _CharT, _Traits > * _M_streambuf
iostate _M_streambuf_state
basic_ostream< _CharT, _Traits > * _M_tie
streamsize _M_width
_Words * _M_word
int _M_word_size
_Words _M_word_zero

Detailed Description

  template<typename _CharT, typename _Traits>
class std::basic_ios< _CharT, _Traits >" Template class basic_ios, virtual base class for all stream classes.

Template Parameters:
    _CharT Type of character stream.
    _Traits Traits for character type, defaults to char_traits<_CharT>.

Most of the member functions called dispatched on stream objects (e.g., std::cout.foo(bar);) are consolidated in this class.

Definition at line 77 of file iosfwd.

Member Typedef Documentation

  template<typename _CharT, typename _Traits> typedef ctype<_CharT> std::basic_ios< _CharT, _Traits >::__ctype_type
These are non-standard types.

Definition at line 87 of file basic_ios.h.

  template<typename _CharT, typename _Traits> typedef num_get<_CharT, istreambuf_iterator<_CharT, _Traits> > std::basic_ios< _CharT, _Traits >::__num_get_type
These are non-standard types.

Definition at line 91 of file basic_ios.h.

  template<typename _CharT, typename _Traits> typedef num_put<_CharT, ostreambuf_iterator<_CharT, _Traits> > std::basic_ios< _CharT, _Traits >::__num_put_type
These are non-standard types.

Definition at line 89 of file basic_ios.h.

  template<typename _CharT, typename _Traits> typedef _CharT std::basic_ios< _CharT, _Traits >::char_type
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 76 of file basic_ios.h.

  typedef void(* std::ios_base::event_callback) (event __e, ios_base &__b, int __i) [inherited]

The type of an event callback function.

Parameters:
    __e One of the members of the event enum.
    __b Reference to the ios_base object.
    __i The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 504 of file ios_base.h.

  typedef _Ios_Fmtflags std::ios_base::fmtflags [inherited]

This is a bitmask type. _Ios_Fmtflags is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

•   boolalpha

•   dec

•   fixed

•   hex

•   internal

•   left

•   oct

•   right

•   scientific

•   showbase

•   showpoint

•   showpos

•   skipws

•   unitbuf

•   uppercase

•   adjustfield

•   basefield

•   floatfield

Definition at line 323 of file ios_base.h.

  template<typename _CharT, typename _Traits> typedef _Traits::int_type std::basic_ios< _CharT, _Traits >::int_type
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 77 of file basic_ios.h.

  typedef _Ios_Iostate std::ios_base::iostate [inherited]

This is a bitmask type. _Ios_Iostate is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

•   badbit

•   eofbit

•   failbit

•   goodbit

Definition at line 398 of file ios_base.h.

  template<typename _CharT, typename _Traits> typedef _Traits::off_type std::basic_ios< _CharT, _Traits >::off_type
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 79 of file basic_ios.h.

  typedef _Ios_Openmode std::ios_base::openmode [inherited]

This is a bitmask type. _Ios_Openmode is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

•   app

•   ate

•   binary

•   in

•   out

•   trunc

Definition at line 429 of file ios_base.h.

  template<typename _CharT, typename _Traits> typedef _Traits::pos_type std::basic_ios< _CharT, _Traits >::pos_type
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 78 of file basic_ios.h.

  typedef _Ios_Seekdir std::ios_base::seekdir [inherited]

This is an enumerated type. _Ios_Seekdir is implementation-defined. Defined values of type seekdir are:

•   beg

•   cur, equivalent to SEEK_CUR in the C standard library.

•   end, equivalent to SEEK_END in the C standard library.

Definition at line 461 of file ios_base.h.

  template<typename _CharT, typename _Traits> typedef _Traits std::basic_ios< _CharT, _Traits >::traits_type
These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 80 of file basic_ios.h.

Member Enumeration Documentation

  enum std::ios_base::event [inherited]

The set of events that may be passed to an event callback. erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Definition at line 487 of file ios_base.h.

Constructor & Destructor Documentation

  template<typename _CharT, typename _Traits> std::basic_ios< _CharT, _Traits >::basic_ios (basic_streambuf< _CharT, _Traits > * __sb) [inline], [explicit]

Constructor performs initialization. The parameter is passed by derived streams.

Definition at line 270 of file basic_ios.h.

  template<typename _CharT, typename _Traits> virtual std::basic_ios< _CharT, _Traits >::~basic_ios () [inline], [virtual]

Empty. The destructor does nothing. More specifically, it does not destroy the streambuf held by rdbuf().

Definition at line 282 of file basic_ios.h.

  template<typename _CharT, typename _Traits> std::basic_ios< _CharT, _Traits >::basic_ios () [inline], [protected]

Empty. The default constructor does nothing and is not normally accessible to users.

Definition at line 460 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::basic_ios().

Member Function Documentation

  const locale& std::ios_base::_M_getloc () const [inline], [inherited]

Locale access.

Returns:
    A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 774 of file ios_base.h.

Referenced by std::time_get< _CharT, _InIter >::do_date_order(), std::time_get< _CharT, _InIter >::do_get(), std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::time_put< _CharT, _OutIter >::do_put(), std::num_put< _CharT, _OutIter >::do_put(), std::time_get< _CharT, _InIter >::get(), and std::time_put< _CharT, _OutIter >::put().

  template<typename _CharT, typename _Traits> bool std::basic_ios< _CharT, _Traits >::bad () const [inline]

Fast error checking.

Returns:
    True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 211 of file basic_ios.h.

  template<typename _CharT , typename _Traits > void std::basic_ios< _CharT, _Traits >::clear (iostate __state = goodbit)

[Re]sets the error state.

Parameters:
    __state The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 41 of file basic_ios.tcc.

Referenced by std::basic_ios< char, _Traits >::exceptions(), std::__detail::operator>>(), std::basic_istream< char >::putback(), std::basic_ios< char, _Traits >::rdstate(), std::basic_istream< char >::seekg(), std::basic_ios< char, _Traits >::setstate(), and std::basic_istream< char >::unget().

  template<typename _CharT , typename _Traits > basic_ios< _CharT, _Traits > & std::basic_ios< _CharT, _Traits >::copyfmt (const basic_ios< _CharT, _Traits > & __rhs)

Copies fields of __rhs into this.

Parameters:
    __rhs The source values for the copies.

Returns:
    Reference to this object.

All fields of __rhs are copied into this object except that rdbuf() and rdstate() remain unchanged. All values in the pword and iword arrays are copied. Before copying, each callback is invoked with erase_event. After copying, each (new) callback is invoked with copyfmt_event. The final step is to copy exceptions().

Definition at line 63 of file basic_ios.tcc.

Referenced by std::basic_ios< char, _Traits >::rdbuf().

  template<typename _CharT, typename _Traits> bool std::basic_ios< _CharT, _Traits >::eof () const [inline]

Fast error checking.

Returns:
    True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 190 of file basic_ios.h.

  template<typename _CharT, typename _Traits> iostate std::basic_ios< _CharT, _Traits >::exceptions () const [inline]

Throwing exceptions on errors.

Returns:
    The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 222 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::copyfmt(), and std::basic_ios< char, _Traits >::setstate().

  template<typename _CharT, typename _Traits> void std::basic_ios< _CharT, _Traits >::exceptions (iostate __except) [inline]

Throwing exceptions on errors.

Parameters:
    __except The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flag is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

#include <iostream>
#include <fstream>
#include <exception>

int main()
{
    std::set_terminate (__gnu_cxx::__verbose_terminate_handler);

    std::ifstream f ("/etc/motd");

    std::cerr << "Setting badbit;
    f.setstate (std::ios_base::badbit);

    std::cerr << "Setting exception mask;
    f.exceptions (std::ios_base::badbit);
}

Definition at line 257 of file basic_ios.h.

  template<typename _CharT, typename _Traits> bool std::basic_ios< _CharT, _Traits >::fail () const [inline]

Fast error checking.

Returns:
    True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 201 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::operator bool(), std::basic_ios< char, _Traits >::operator!(), and std::regex_traits< _Ch_type >::value().

  template<typename _CharT, typename _Traits> char_type std::basic_ios< _CharT, _Traits >::fill () const [inline]

Retrieves the empty character.

Returns:
    The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 370 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::copyfmt(), and std::basic_ios< char, _Traits >::fill().

  template<typename _CharT, typename _Traits> char_type std::basic_ios< _CharT, _Traits >::fill (char_type __ch) [inline]

Sets a new empty character.

Parameters:
    __ch The new character.

Returns:
    The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 390 of file basic_ios.h.

  fmtflags std::ios_base::flags () const [inline], [inherited]

Access to format flags.

Returns:
    The format control flags for both input and output.

Definition at line 619 of file ios_base.h.

Referenced by std::basic_ios< char, _Traits >::copyfmt(), std::mersenne_twister_engine< uint_fast32_t, 32, 624, 397, 31, 0x9908b0dfUL, 11, 0xffffffffUL, 7, 0x9d2c5680UL, 15, 0xefc60000UL, 18, 1812433253UL >::discard(), std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::subtract_with_carry_engine< _UIntType, __w, __s, __r >::operator()(), std::discard_block_engine< _RandomNumberEngine, __p, __r >::operator()(), std::shuffle_order_engine< _RandomNumberEngine, __k >::operator()(), std::basic_ostream< char >::operator<<(), std::operator<<(), std::__detail::operator>>(), std::operator>>(), and std::linear_congruential_engine< _UIntType, __a, __c, __m >::seed().

  fmtflags std::ios_base::flags (fmtflags __fmtfl) [inline], [inherited]

Setting new format flags all at once.

Parameters:
    __fmtfl The new flags to set.

Returns:
    The previous format control flags.

This function overwrites all the format flags with __fmtfl.

Definition at line 630 of file ios_base.h.

  locale std::ios_base::getloc () const [inline], [inherited]

Locale access.

Returns:
    A copy of the current locale.

If imbue(loc) has previously been called, then this function returns loc. Otherwise, it returns a copy of std::locale(), the global C++ locale.

Definition at line 763 of file ios_base.h.

Referenced by std::basic_ios< char, _Traits >::copyfmt(), std::money_put< _CharT, _OutIter >::do_put(), and std::ws().

  template<typename _CharT, typename _Traits> bool std::basic_ios< _CharT, _Traits >::good () const [inline]

Fast error checking.

Returns:
    True if no error flags are set.

A wrapper around rdstate.

Definition at line 180 of file basic_ios.h.

Referenced by std::__detail::operator>>(), std::basic_ostream< _CharT, _Traits >::sentry::sentry(), and std::basic_istream< _CharT, _Traits >::sentry::sentry().

  template<typename _CharT , typename _Traits > locale std::basic_ios< _CharT, _Traits >::imbue (const locale & __loc)

Moves to a new locale.

Parameters:
    __loc The new locale.

Returns:
    The previous locale.

Calls ios_base::imbue(loc), and if a stream buffer is associated with this stream, calls that buffer's pubimbue(loc).

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 114 of file basic_ios.tcc.

Referenced by std::basic_ios< char, _Traits >::fill().

  template<typename _CharT, typename _Traits> void std::basic_ios< _CharT, _Traits >::init (basic_streambuf< _CharT, _Traits > * __sb) [protected]

All setup is performed here. This is called from the public constructor. It is not virtual and cannot be redefined.

Definition at line 126 of file basic_ios.tcc.

Referenced by std::basic_ios< char, _Traits >::basic_ios().

  long& std::ios_base::iword (int __ix) [inline], [inherited]

Access to integer array.

Parameters:
    __ix Index into the array.

Returns:
    A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 809 of file ios_base.h.

  template<typename _CharT, typename _Traits> char std::basic_ios< _CharT, _Traits >::narrow (char_type __c, char __dfault) const [inline]

Squeezes characters.

Parameters:
    __c The character to narrow.
    __dfault The character to narrow.

Returns:
    The narrowed character.

Maps a character of char_type to a character of char, if possible.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).narrow(c,dfault)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 430 of file basic_ios.h.

  template<typename _CharT, typename _Traits> std::basic_ios< _CharT, _Traits >::operator bool () const [inline], [explicit]

The quick-and-easy status check. This allows you to write constructs such as if (!a_stream) ... and while (a_stream) ...

Definition at line 117 of file basic_ios.h.

  template<typename _CharT, typename _Traits> bool std::basic_ios< _CharT, _Traits >::operator! () const [inline]

The quick-and-easy status check. This allows you to write constructs such as if (!a_stream) ... and while (a_stream) ...

Definition at line 125 of file basic_ios.h.

  streamsize std::ios_base::precision () const [inline], [inherited]

Flags access.

Returns:
    The precision to generate on certain output operations.

Be careful if you try to give a definition of precision here; see DR 189.

Definition at line 689 of file ios_base.h.

Referenced by std::basic_ios< char, _Traits >::copyfmt().

  streamsize std::ios_base::precision (streamsize __prec) [inline], [inherited]

Changing flags.

Parameters:
    __prec The new precision value.

Returns:
    The previous value of precision().

Definition at line 698 of file ios_base.h.

  void*& std::ios_base::pword (int __ix) [inline], [inherited]

Access to void pointer array.

Parameters:
    __ix Index into the array.

Returns:
    A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 830 of file ios_base.h.

  template<typename _CharT, typename _Traits> basic_streambuf<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::rdbuf () const [inline]

Accessing the underlying buffer.

Returns:
    The current stream buffer.

This does not change the state of the stream.

Definition at line 321 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::rdbuf(), and std::ws().

  template<typename _CharT, typename _Traits> basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf (basic_streambuf< _CharT, _Traits > * __sb)

Changing the underlying buffer.

Parameters:
    __sb The new stream buffer.

Returns:
    The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument rdbuf(), which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class. For example:

std::fstream     foo;         // or some other derived type
std::streambuf*  p = .....;

foo.ios::rdbuf(p);            // ios == basic_ios<char>

Definition at line 53 of file basic_ios.tcc.

  template<typename _CharT, typename _Traits> iostate std::basic_ios< _CharT, _Traits >::rdstate () const [inline]

Returns the error state of the stream buffer.

Returns:
    A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 137 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::bad(), std::basic_ios< char, _Traits >::eof(), std::basic_ios< char, _Traits >::fail(), std::basic_ios< char, _Traits >::good(), std::basic_istream< char >::putback(), std::basic_istream< char >::seekg(), std::basic_ios< char, _Traits >::setstate(), and std::basic_istream< char >::unget().

  void std::ios_base::register_callback (event_callback __fn, int __index) [inherited]

Add the callback __fn with parameter __index.

Parameters:
    __fn The function to add.
    __index The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

  fmtflags std::ios_base::setf (fmtflags __fmtfl) [inline], [inherited]

Setting new format flags.

Parameters:
    __fmtfl Additional flags to set.

Returns:
    The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 646 of file ios_base.h.

Referenced by std::boolalpha(), std::dec(), std::fixed(), std::hex(), std::hexfloat(), std::left(), std::oct(), std::__detail::operator>>(), std::right(), std::scientific(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

  fmtflags std::ios_base::setf (fmtflags __fmtfl, fmtflags __mask) [inline], [inherited]

Setting new format flags.

Parameters:
    __fmtfl Additional flags to set.
    __mask The flags mask for fmtfl.

Returns:
    The previous format control flags.

This function clears mask in the format flags, then sets fmtfl & mask. An example mask is ios_base::adjustfield.

Definition at line 663 of file ios_base.h.

  template<typename _CharT, typename _Traits> void std::basic_ios< _CharT, _Traits >::setstate (iostate __state) [inline]

Sets additional flags in the error state.

Parameters:
    __state The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 157 of file basic_ios.h.

Referenced by std::operator<<(), std::basic_ostream< _CharT, _Traits >::sentry::sentry(), and std::ws().

  static bool std::ios_base::sync_with_stdio (bool __sync = true) [static], [inherited]

Interaction with the standard C I/O objects.

Parameters:
    __sync Whether to synchronize or not.

Returns:
    True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary

  template<typename _CharT, typename _Traits> basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie () const [inline]

Fetches the current tied stream.

Returns:
    A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, std::cin is tied to std::cout.

Definition at line 295 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::basic_ios(), std::basic_ios< char, _Traits >::copyfmt(), and std::basic_ostream< _CharT, _Traits >::sentry::sentry().

  template<typename _CharT, typename _Traits> basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::tie (basic_ostream< _CharT, _Traits > * __tiestr) [inline]

Ties this stream to an output stream.

Parameters:
    __tiestr The output stream.

Returns:
    The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 307 of file basic_ios.h.

  void std::ios_base::unsetf (fmtflags __mask) [inline], [inherited]

Clearing format flags.

Parameters:
    __mask The flags to unset.

This function clears __mask in the format flags.

Definition at line 678 of file ios_base.h.

Referenced by std::defaultfloat(), std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), and std::nouppercase().

  template<typename _CharT, typename _Traits> char_type std::basic_ios< _CharT, _Traits >::widen (char __c) const [inline]

Widens characters.

Parameters:
    __c The character to widen.

Returns:
    The widened character.

Maps a character of char to a character of char_type.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).widen(c)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 449 of file basic_ios.h.

Referenced by std::basic_ios< char, _Traits >::fill(), std::getline(), and std::tr2::operator>>().

  streamsize std::ios_base::width () const [inline], [inherited]

Flags access.

Returns:
    The minimum field width to generate on output operations.

Minimum field width refers to the number of characters.

Definition at line 712 of file ios_base.h.

Referenced by std::basic_ios< char, _Traits >::copyfmt(), std::money_get< _CharT, _InIter >::do_get(), and std::num_put< _CharT, _OutIter >::do_put().

  streamsize std::ios_base::width (streamsize __wide) [inline], [inherited]

Changing flags.

Parameters:
    __wide The new width value.

Returns:
    The previous value of width().

Definition at line 721 of file ios_base.h.

  static int std::ios_base::xalloc () [static], [inherited]

Access to unique indices.

Returns:
    An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

Member Data Documentation

  const fmtflags std::ios_base::adjustfield [static], [inherited]

A mask of left|right|internal. Useful for the 2-arg form of setf.

Definition at line 378 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::internal(), std::left(), and std::right().

  const openmode std::ios_base::app [static], [inherited]

Seek to end before each write.

Definition at line 432 of file ios_base.h.

  const openmode std::ios_base::ate [static], [inherited]

Open and seek to end immediately after opening.

Definition at line 435 of file ios_base.h.

  const iostate std::ios_base::badbit [static], [inherited]

Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).

Definition at line 402 of file ios_base.h.

Referenced by std::basic_ios< char, _Traits >::bad(), std::basic_ios< char, _Traits >::fail(), and std::operator<<().

  const fmtflags std::ios_base::basefield [static], [inherited]

A mask of dec|oct|hex. Useful for the 2-arg form of setf.

Definition at line 381 of file ios_base.h.

Referenced by std::dec(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::hex(), std::oct(), and std::basic_ostream< char >::operator<<().

  const seekdir std::ios_base::beg [static], [inherited]

Request a seek relative to the beginning of the stream.

Definition at line 464 of file ios_base.h.

Referenced by __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::sync().

  const openmode std::ios_base::binary [static], [inherited]

Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary.

Definition at line 440 of file ios_base.h.

  const fmtflags std::ios_base::boolalpha [static], [inherited]

Insert/extract bool in alphabetic rather than numeric format.

Definition at line 326 of file ios_base.h.

Referenced by std::boolalpha(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::noboolalpha().

  const seekdir std::ios_base::cur [static], [inherited]

Request a seek relative to the current position within the sequence.

Definition at line 467 of file ios_base.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), and __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::sync().

  const fmtflags std::ios_base::dec [static], [inherited]

Converts integer input or generates integer output in decimal base.

Definition at line 329 of file ios_base.h.

Referenced by std::dec().

  const seekdir std::ios_base::end [static], [inherited]

Request a seek relative to the current end of the sequence.

Definition at line 470 of file ios_base.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

  const iostate std::ios_base::eofbit [static], [inherited]

Indicates that an input operation reached the end of an input sequence.

Definition at line 405 of file ios_base.h.

Referenced by std::time_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ios< char, _Traits >::eof(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< char >::putback(), std::basic_istream< char >::seekg(), std::basic_istream< char >::unget(), and std::ws().

  const iostate std::ios_base::failbit [static], [inherited]

Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.

Definition at line 410 of file ios_base.h.

Referenced by std::time_get< _CharT, _InIter >::do_date_order(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ios< char, _Traits >::fail(), std::time_get< _CharT, _InIter >::get(), and std::basic_ostream< _CharT, _Traits >::sentry::sentry().

  const fmtflags std::ios_base::fixed [static], [inherited]

Generate floating-point output in fixed-point notation.

Definition at line 332 of file ios_base.h.

Referenced by std::fixed(), and std::hexfloat().

  const fmtflags std::ios_base::floatfield [static], [inherited]

A mask of scientific|fixed. Useful for the 2-arg form of setf.

Definition at line 384 of file ios_base.h.

Referenced by std::defaultfloat(), std::fixed(), std::hexfloat(), and std::scientific().

  const iostate std::ios_base::goodbit [static], [inherited]

Indicates all is well.

Definition at line 413 of file ios_base.h.

Referenced by std::time_get< _CharT, _InIter >::do_date_order(), std::time_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ostream< char >::flush(), std::basic_istream< char >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< char >::getline(), std::basic_istream< char >::ignore(), std::basic_ostream< char >::operator<<(), std::basic_istream< char >::operator>>(), std::operator>>(), std::basic_istream< char >::peek(), std::basic_ostream< char >::put(), std::basic_istream< char >::putback(), std::basic_ios< char, _Traits >::rdstate(), std::basic_istream< char >::read(), std::basic_istream< char >::readsome(), std::basic_istream< char >::seekg(), std::basic_ostream< char >::seekp(), std::basic_ostream< _CharT, _Traits >::sentry::sentry(), std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_istream< char >::sync(), and std::basic_istream< char >::unget().

  const fmtflags std::ios_base::hex [static], [inherited]

Converts integer input or generates integer output in hexadecimal base.

Definition at line 335 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::hex(), and std::basic_ostream< char >::operator<<().

  const openmode std::ios_base::in [static], [inherited]

Open for input. Default for ifstream and fstream.

Definition at line 443 of file ios_base.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::sync(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow().

  const fmtflags std::ios_base::internal [static], [inherited]

Adds fill characters at a designated internal point in certain generated output, or identical to right if no such point is designated.

Definition at line 340 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::do_get(), and std::internal().

  const fmtflags std::ios_base::left [static], [inherited]

Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.)

Definition at line 344 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::left().

  const fmtflags std::ios_base::oct [static], [inherited]

Converts integer input or generates integer output in octal base.

Definition at line 347 of file ios_base.h.

Referenced by std::oct(), and std::basic_ostream< char >::operator<<().

  const openmode std::ios_base::out [static], [inherited]

Open for output. Default for ofstream and fstream.

Definition at line 446 of file ios_base.h.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::sync().

  const fmtflags std::ios_base::right [static], [inherited]

Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.)

Definition at line 351 of file ios_base.h.

Referenced by std::right().

  const fmtflags std::ios_base::scientific [static], [inherited]

Generates floating-point output in scientific notation.

Definition at line 354 of file ios_base.h.

Referenced by std::hexfloat(), and std::scientific().

  const fmtflags std::ios_base::showbase [static], [inherited]

Generates a prefix indicating the numeric base of generated integer output.

Definition at line 358 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::noshowbase(), and std::showbase().

  const fmtflags std::ios_base::showpoint [static], [inherited]

Generates a decimal-point character unconditionally in generated floating-point output.

Definition at line 362 of file ios_base.h.

Referenced by std::noshowpoint(), and std::showpoint().

  const fmtflags std::ios_base::showpos [static], [inherited]

Generates a + sign in non-negative generated numeric output.

Definition at line 365 of file ios_base.h.

Referenced by std::noshowpos(), and std::showpos().

  const fmtflags std::ios_base::skipws [static], [inherited]

Skips leading white space before certain input operations.

Definition at line 368 of file ios_base.h.

Referenced by std::noskipws(), and std::skipws().

  const openmode std::ios_base::trunc [static], [inherited]

Open for input. Default for ofstream.

Definition at line 449 of file ios_base.h.

  const fmtflags std::ios_base::unitbuf [static], [inherited]

Flushes output after each output operation.

Definition at line 371 of file ios_base.h.

Referenced by std::nounitbuf(), and std::unitbuf().

  const fmtflags std::ios_base::uppercase [static], [inherited]

Replaces certain lowercase letters with their uppercase equivalents in generated output.

Definition at line 375 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::nouppercase(), and std::uppercase().

Author

Generated automatically by Doxygen for libstdc++ from the source code.